#include "TCPsocket.h"

/*==============================================================================
  INIT WIN32 SOCKETS
==============================================================================*/
void init_socket()
{
 #ifdef WIN32
 WSADATA wsa;
 if (WSAStartup(0x0202, &wsa) != 0)
 {
    socket_error("WSAStartup()");
    getchar();
    exit (1);
 }
 #endif
}

/*==============================================================================
  CONNECTION TCP
==============================================================================*/
SOCKET connection_TCP(char *serv, unsigned short port)
{
 SOCKET sk=-1;
 struct sockaddr_in ServAddr;
 struct hostent *he;

 //printf("gethostbyname(%s)\n", serv);
 if ((he = gethostbyname(serv)) == NULL)
    {socket_error("Gethostbyname()"); return -1;}

 //printf("Socket()\n");
 if ((sk = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET)
    {socket_error("socket()\n"); return -1;}

 //printf("fill address\n");
 ServAddr.sin_family = AF_INET;
 ServAddr.sin_port   = htons(port);
 ServAddr.sin_addr   = *((struct in_addr *)he->h_addr);

 //printf("connect()\n");
 if (connect(sk, (struct sockaddr*)&ServAddr, sizeof(ServAddr))==-1)
 {
    socket_error("connect()");
    closesocket(sk);
    return -1;
 }
 //printf("%s connected to server %s\n", serv);
 return sk;
}

/*==============================================================================
  LIRE UNE COURTE REPONSE DU SERVEUR
==============================================================================*/
void lire(SOCKET sk)
{
 char buf[255];
 int i = recv(sk, buf, 255, 0);
 buf[i]=0;
 //printf("[%s]\n", buf);
}



/*==============================================================================
  ENVOIE UNE COMMANDE POP
==============================================================================*/
void ecrire(SOCKET sk, char *msg, int len)
{
 int i = send(sk, msg, len, 0);
 if (i != len) socket_error("send()");
 //printf("(%s)\n", msg);
}
/*------------------------------------------------------------------------------
  ENVOIE UN GROS STRING
------------------------------------------------------------------------------*/
void envoi_big_paquet(SOCKET sk, char *s, long taille, int ms)
{
 #define PACKETSIZE 1024
 long reste  = taille; //octets qu'il reste  envoyer
 long envoye = 0; //octets dj envoys
 int i;

 while (envoye <= taille)
 {
  if (reste < PACKETSIZE) //dernier paquet
  {
   i = send(sk, s + envoye, reste, 0);
   //printf("-----> dernier paquet:%ld\n", reste);
   break;
  }
  else
   i = send(sk, s + envoye, PACKETSIZE, 0);

  envoye += i;
  reste -= i;
  sleep(ms);
  //printf("(%d) -> %ld/%ld octets\n", i, envoye, taille);
 }
}



/*==============================================================================
  Affiche le numro d'erreur du socket, en cas de problme
==============================================================================*/
void socket_error(char *msg)
{
 char str[1024];
 #ifdef WIN32
  LPVOID lpMsgBuf;
  FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |FORMAT_MESSAGE_FROM_SYSTEM |
    FORMAT_MESSAGE_IGNORE_INSERTS, NULL,WSAGetLastError(), 0, (LPTSTR)&lpMsgBuf,
    0, NULL);
  sprintf(str,"%s : %s", msg,(LPCTSTR)lpMsgBuf);
  //MessageBox (hwnd,str,"POP3 Socket Error",MB_OK | MB_ICONEXCLAMATION);
  LocalFree( lpMsgBuf );
  printf("%s", str);
 #else
 perror(msg);
 #endif
}








